<?php
namespace Neklo\Scheduler\Controller\Adminhtml\Schedule;

use Neklo\Scheduler\Controller\Adminhtml;
use Neklo\Scheduler\Api\Data\SchedulerInterface;

class Save extends Adminhtml\Operation
{
    public function execute()
    {
        $redirectBack = $this->getRequest()->getParam('back', false);
        $data = $this->getRequest()->getParams();
        $id = $data[SchedulerInterface::SCHEDULE_ID];

        try {
            if ($id) {
                /* @var $model \Magento\Cron\Model\Schedule */
                $model = $this->_objectManager
                    ->create('Magento\Cron\Model\Schedule');
                $model->load($id);
                if ($model->getId()) {
                    $model->setData($data)->save();
                    $name = $model->getJobCode();
                    $time = $model->getScheduledAt();
                    $this->messageManager->addSuccess(
                        __('Schedule %1 at %2 saved', $name, $time));
                }
            } else {
                $this->messageManager->addError(__('Data ID missing - error'));
            }
        } catch (\Exception $e) {
            $this->log->critical($e->getMessage());
            $this->messageManager->addError(__('Operation error'));
            $this->_session->setFormData($data);
            return $this->_redirect('*/schedule/edit',
                ['id' => $id, 'back' => null, '_current' => true]);
        }
        return $this->_redirect(static::REDIRECT_URL);
    }

}
